#include "zsc_acs.h"

#include <GDCC.h>
#include <ACS_ZDoom.h>
#include <stdlib.h>


// Extern Objects -------------------------------------------------------------

zsc_arg_t zsc_args[10];
zsc_arg_t zsc_ret;


// Static Objects -------------------------------------------------------------

static size_t zsstr_len;
static char *zsstr_buf;


// Extern Functions -----------------------------------------------------------

//
// zscSetArg
//
[[extern("ACS"), call("ScriptS")]]
void zscSetArg(int arg, int value)
{
    zsc_args[arg].i = value;
}

//
// zscStrBegin
//
[[extern("ACS"), call("ScriptS")]]
void zscStrBegin(int len)
{
    zsstr_buf = realloc(zsstr_buf, len + 1);
    zsstr_len = len;
    
    zsstr_buf[zsstr_len] = '\0';
}

//
// zscStrChar
//
[[extern("ACS"), call("ScriptS")]]
void zscStrChar(int idx, char c)
{
    zsstr_buf[idx] = c;
}

//
// zscStrEnd
//
[[extern("ACS"), call("ScriptS")]]
void zscStrEnd(int arg)
{
    ACS_BeginStrParam();
    
    ACS_PrintGlobalCharArray((int)zsstr_buf, __GDCC__Sta);
    
    zsc_args[arg].s = ACS_EndStrParam();
}

//
// zscStrRetLength
//
[[extern("ACS"), call("ScriptS")]]
int zscStrRetLength()
{
    return ACS_StrLen(zsc_ret.s);
}

//
// zscStrRetChar
//
[[extern("ACS"), call("ScriptS")]]
int zscStrRetChar(int idx)
{
    return ACS_GetChar(zsc_ret.s, idx);
}
